Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34921)
@@ -1170,11 +1550,27 @@
                 $noWarn = 1;
             }
-            # allow protected tags to be copied if specified explicitly
-            $$opts{Protected} = ($$set[2] eq '*' ? undef : 1);
+            if ($$set[1] eq '*' or $$set[3]{WILD}) {
+                # don't copy from protected binary tags when using wildcards
+                next if $$srcExifTool{TAG_INFO}{$tag}{Protected} and
+                        $$srcExifTool{TAG_INFO}{$tag}{Binary};
+                # don't copy to protected tags when using wildcards
+                delete $$opts{Protected};
+                # don't copy flattened tags if copying structures too when copying all
+                $$opts{NoFlat} = $structOpt eq '2' ? 1 : 0;
+            } else {
+                # allow protected tags to be copied if specified explicitly
+                $$opts{Protected} = 1 unless $dstTag =~ /[?*]/;
+                delete $$opts{NoFlat};
+            }
             # set value(s) for this tag
             my ($rtn, $wrn) = $self->SetNewValue($dstTag, $val, %$opts);
+            # this was added in version 9.14, and allowed actions like "-subject<all" to
+            # write values of multiple tags into a list, but it had the side effect of
+            # duplicating items if there were multiple list tags with the same name
+            # (eg. -use mwg "-creator<creator"), so disable this as of ExifTool 9.36:
+            # $$opts{Replace} = 0;    # accumulate values from tags matching a single argument
             if ($wrn and not $noWarn) {
                 # return this warning
-                $rtnInfo{NextTagKey(\%rtnInfo, 'Warning')} = $wrn;
+                $rtnInfo{NextFreeTagKey(\%rtnInfo, 'Warning')} = $wrn;
                 $noWarn = 1;
             }
@@ -1187,20 +1583,22 @@
 #------------------------------------------------------------------------------
 # Get new value(s) for tag
-# Inputs: 0) ExifTool object reference, 1) tag name or tagInfo hash ref
+# Inputs: 0) ExifTool object reference, 1) tag name (or tagInfo or nvHash ref, not public)
 #         2) optional pointer to return new value hash reference (not part of public API)
-#    or   0) new value hash reference (not part of public API)
 # Returns: List of new Raw values (list may be empty if tag is being deleted)
 # Notes: 1) Preferentially returns new value from Extra table if writable Extra tag exists
 # 2) Must call AFTER IsOverwriting() returns 1 to get proper value for shifted times
 # 3) Tag name is case sensitive and may be prefixed by family 0 or 1 group name
-sub GetNewValues($;$$)
+# 4) Value may have been modified by CHECK_PROC routine after ValueConv
+sub GetNewValue($$;$)
 {
     local $_;
+    my $self = shift;
+    my $tag = shift;
     my $nvHash;
-    if (ref $_[0] eq 'HASH') {
-        $nvHash = shift;
+    if ((ref $tag eq 'HASH' and $$tag{IsNVH}) or not defined $tag) {
+        $nvHash = $tag;
     } else {
-        my ($self, $tag, $newValueHashPt) = @_;
-        if ($self->{NEW_VALUE}) {
+        my $newValueHashPt = shift;
+        if ($$self{NEW_VALUE}) {
             my ($group, $tagInfo);
             if (ref $tag) {
@@ -1212,19 +1610,23 @@
             } else {
                 # separate group from tag name
-                $group = $1 if $tag =~ s/(.*)://;
+                my @groups;
+                @groups = split ':', $1 if $tag =~ s/(.*)://;
                 my @tagInfoList = FindTagInfo($tag);
                 # decide which tag we want
 GNV_TagInfo:    foreach $tagInfo (@tagInfoList) {
                     my $nvh = $self->GetNewValueHash($tagInfo) or next;
-                    # select tag in specified group if necessary
-                    while ($group and $group ne $$nvh{WriteGroup}) {
+                    # select tag in specified group(s) if necessary
+                    foreach (@groups) {
+                        next if $_ eq $$nvh{WriteGroup};
                         my @grps = $self->GetGroup($tagInfo);
                         if ($grps[0] eq $$nvh{WriteGroup}) {
                             # check family 1 group only if WriteGroup is not specific
-                            last if $group eq $grps[1];
+                            next if $_ eq $grps[1];
                         } else {
                             # otherwise check family 0 group
-                            last if $group eq $grps[0];
+                            next if $_ eq $grps[0];
                         }
+                        # also check family 7
+                        next if /^ID-(.*)/i and IsSameID($$tagInfo{TagID}, $1);
                         # step to next entry in list
                         $nvh = $$nvh{Next} or next GNV_TagInfo;
@@ -1232,5 +1634,5 @@
                     $nvHash = $nvh;
                     # give priority to the one we are creating
-                    last if defined $nvHash->{IsCreating};
+                    last if defined $$nvHash{IsCreating};
                 }
             }
@@ -1239,52 +1641,57 @@
         $newValueHashPt and $$newValueHashPt = $nvHash;
     }
-    if ($nvHash and $nvHash->{Value}) {
-        my $vals = $nvHash->{Value};
-        # do inverse raw conversion if necessary
-        if ($nvHash->{TagInfo}{RawConvInv}) {
-            my @copyVals = @$vals;  # modify a copy of the values
-            $vals = \@copyVals;
-            my $tagInfo = $$nvHash{TagInfo};
-            my $conv = $$tagInfo{RawConvInv};
-            my $self = $nvHash->{Self};
-            my ($val, $checkProc);
-            my $table = $tagInfo->{Table};
-            $checkProc = $$table{CHECK_PROC} if $table;
-            local $SIG{'__WARN__'} = \&SetWarning;
-            undef $evalWarning;
-            foreach $val (@$vals) {
-                if (ref($conv) eq 'CODE') {
-                    $val = &$conv($val, $self);
-                } else {
-                    #### eval RawConvInv ($self, $val, $taginfo)
-                    $val = eval $conv;
-                    $@ and $evalWarning = $@;
-                }
-                if ($evalWarning) {
-                    # an empty warning ("\n") ignores tag with no error
-                    if ($evalWarning ne "\n") {
-                        my $err = CleanWarning() . " in $$tagInfo{Name} (RawConvInv)";
-                        $self->Warn($err);
-                    }
-                    @$vals = ();
-                    last;
-                }
-                # must check value now
-                next unless $checkProc;
+    unless ($nvHash and $$nvHash{Value}) {
+        return () if wantarray;  # return empty list
+        return undef;
+    }
+    my $vals = $$nvHash{Value};
+    # do inverse raw conversion if necessary
+    # - must also check after doing a Shift
+    if ($$nvHash{TagInfo}{RawConvInv} or $$nvHash{Shift}) {
+        my @copyVals = @$vals;  # modify a copy of the values
+        $vals = \@copyVals;
+        my $tagInfo = $$nvHash{TagInfo};
+        my $conv = $$tagInfo{RawConvInv};
+        my $table = $$tagInfo{Table};
+        my ($val, $checkProc);
+        $checkProc = $$table{CHECK_PROC} if $$nvHash{Shift} and $table;
+        local $SIG{'__WARN__'} = \&SetWarning;
+        undef $evalWarning;
+        foreach $val (@$vals) {
+            # must check value now if it was shifted
+            if ($checkProc) {
                 my $err = &$checkProc($self, $tagInfo, \$val);
                 if ($err or not defined $val) {
                     $err or $err = 'Error generating raw value';
-                    $self->Warn("$err for $$tagInfo{Name}");
+                    $self->WarnOnce("$err for $$tagInfo{Name}");
                     @$vals = ();
                     last;
                 }
-            }
-        }
-        # return our value(s)
-        return @$vals if wantarray;
-        return $$vals[0];
-    }
-    return () if wantarray;  # return empty list
-    return undef;
+                next unless $conv;
+            } else {
+                last unless $conv;
+            }
+            # do inverse raw conversion
+            if (ref($conv) eq 'CODE') {
+                $val = &$conv($val, $self);
+            } else {
+                #### eval RawConvInv ($self, $val, $tagInfo)
+                $val = eval $conv;
+                $@ and $evalWarning = $@;
+            }
+            if ($evalWarning) {
+                # an empty warning ("\n") ignores tag with no error
+                if ($evalWarning ne "\n") {
+                    my $err = CleanWarning() . " in $$tagInfo{Name} (RawConvInv)";
+                    $self->WarnOnce($err);
+                }
+                @$vals = ();
+                last;
+            }
+        }
+    }
+    # return our value(s)
+    return @$vals if wantarray;
+    return $$vals[0];
 }
 
@@ -1292,29 +1699,25 @@
 # Return the total number of new values set
 # Inputs: 0) ExifTool object reference
-# Returns: Scalar context) Number of new values that have been set
-#          List context) Number of new values, number of "pseudo" values
+# Returns: Scalar context) Number of new values that have been set (incl pseudo)
+#          List context) Number of new values (incl pseudo), number of "pseudo" values
 # ("pseudo" values are those which don't require rewriting the file to change)
 sub CountNewValues($)
 {
     my $self = shift;
-    my $newVal = $self->{NEW_VALUE};
-    my $num = 0;
-    my $tag;
+    my $newVal = $$self{NEW_VALUE};
+    my ($num, $pseudo) = (0, 0);
     if ($newVal) {
-        $num += scalar keys %$newVal;
-        # don't count "fake" tags (only in Extra table)
-        foreach $tag (qw{Geotag Geosync}) {
-            --$num if defined $$newVal{$Image::ExifTool::Extra{$tag}};
-        }
-    }
-    $num += scalar keys %{$self->{DEL_GROUP}};
+        $num = scalar keys %$newVal;
+        my $nv;
+        foreach $nv (values %$newVal) {
+            my $tagInfo = $$nv{TagInfo};
+            # don't count tags that don't write anything
+            $$tagInfo{WriteNothing} and --$num, next;
+            # count the number of pseudo tags included
+            $$tagInfo{WritePseudo} and ++$pseudo;
+        }
+    }
+    $num += scalar keys %{$$self{DEL_GROUP}};
     return $num unless wantarray;
-    my $pseudo = 0;
-    if ($newVal) {
-        # (Note: all writable "pseudo" tags must be found in Extra table)
-        foreach $tag (qw{FileName Directory FileModifyDate}) {
-            ++$pseudo if defined $$newVal{$Image::ExifTool::Extra{$tag}};
-        }
-    }
     return ($num, $pseudo);
 }
@@ -1323,25 +1726,26 @@
 # Save new values for subsequent restore
 # Inputs: 0) ExifTool object reference
+# Returns: Number of times new values have been saved
+# Notes: increments SAVE_COUNT flag each time routine is called
 sub SaveNewValues($)
 {
     my $self = shift;
-    my $newValues = $self->{NEW_VALUE};
+    my $newValues = $$self{NEW_VALUE};
+    my $saveCount = ++$$self{SAVE_COUNT};
     my $key;
     foreach $key (keys %$newValues) {
         my $nvHash = $$newValues{$key};
         while ($nvHash) {
-            $nvHash->{Save} = 1;  # set Save flag
-            $nvHash = $nvHash->{Next};
+            # set Save count if not done already
+            $$nvHash{Save} or $$nvHash{Save} = $saveCount;
+            $nvHash = $$nvHash{Next};
         }
     }
     # initialize hash for saving overwritten new values
-    $self->{SAVE_NEW_VALUE} = { };
+    $$self{SAVE_NEW_VALUE} = { };
     # make a copy of the delete group hash
-    if ($self->{DEL_GROUP}) {
-        my %delGrp = %{$self->{DEL_GROUP}};
-        $self->{SAVE_DEL_GROUP} = \%delGrp;
-    } else {
-        delete $self->{SAVE_DEL_GROUP};
-    }
+    my %delGrp = %{$$self{DEL_GROUP}};
+    $$self{SAVE_DEL_GROUP} = \%delGrp;
+    return $saveCount;
 }
 
@@ -1351,10 +1755,12 @@
 # Notes: Restores saved new values, but currently doesn't restore them in the
 # original order, so there may be some minor side-effects when restoring tags
-# with overlapping groups. ie) XMP:Identifier, XMP-dc:Identifier
+# with overlapping groups. eg) XMP:Identifier, XMP-dc:Identifier
+# Also, this doesn't do the right thing for list-type tags which accumulate
+# values across a save point
 sub RestoreNewValues($)
 {
     my $self = shift;
-    my $newValues = $self->{NEW_VALUE};
-    my $savedValues = $self->{SAVE_NEW_VALUE};
+    my $newValues = $$self{NEW_VALUE};
+    my $savedValues = $$self{SAVE_NEW_VALUE};
     my $key;
     # 1) remove any new values which don't have the Save flag set
@@ -1365,17 +1771,17 @@
             my $nvHash = $$newValues{$key};
             while ($nvHash) {
-                if ($nvHash->{Save}) {
+                if ($$nvHash{Save}) {
                     $lastHash = $nvHash;
                 } else {
                     # remove this entry from the list
                     if ($lastHash) {
-                        $lastHash->{Next} = $nvHash->{Next};
-                    } elsif ($nvHash->{Next}) {
-                        $$newValues{$key} = $nvHash->{Next};
+                        $$lastHash{Next} = $$nvHash{Next};
+                    } elsif ($$nvHash{Next}) {
+                        $$newValues{$key} = $$nvHash{Next};
                     } else {
                         delete $$newValues{$key};
                     }
                 }
-                $nvHash = $nvHash->{Next};
+                $nvHash = $$nvHash{Next};
             }
         }
@@ -1383,52 +1789,65 @@
     # 2) restore saved new values
     if ($savedValues) {
-        $newValues or $newValues = $self->{NEW_VALUE} = { };
+        $newValues or $newValues = $$self{NEW_VALUE} = { };
         foreach $key (keys %$savedValues) {
             if ($$newValues{$key}) {
                 # add saved values to end of list
                 my $nvHash = LastInList($$newValues{$key});
-                $nvHash->{Next} = $$savedValues{$key};
+                $$nvHash{Next} = $$savedValues{$key};
             } else {
                 $$newValues{$key} = $$savedValues{$key};
             }
         }
-        $self->{SAVE_NEW_VALUE} = { };  # reset saved new values
+        $$self{SAVE_NEW_VALUE} = { };  # reset saved new values
     }
     # 3) restore delete groups
-    if ($self->{SAVE_DEL_GROUP}) {
-        my %delGrp = %{$self->{SAVE_DEL_GROUP}};
-        $self->{DEL_GROUP} = \%delGrp;
-    } else {
-        delete $self->{DEL_GROUP};
-    }
-}
-
-#------------------------------------------------------------------------------
-# Set file modification time from FileModifyDate tag
+    my %delGrp = %{$$self{SAVE_DEL_GROUP}};
+    $$self{DEL_GROUP} = \%delGrp;
+}
+
+#------------------------------------------------------------------------------
+# Set filesystem time from from FileModifyDate or FileCreateDate tag
 # Inputs: 0) ExifTool object reference, 1) file name or file ref
-#         2) modify time (-M) of original file (needed for time shift)
+#         2) time (-M or -C) of original file (used for shift; obtained from file if not given)
+#         3) tag name to write (undef for 'FileModifyDate')
+#         4) flag set if argument 2 has already been converted to Unix seconds
 # Returns: 1=time changed OK, 0=nothing done, -1=error setting time
-#          (and increments CHANGED flag if time was changed)
-sub SetFileModifyDate($$;$)
-{
-    my ($self, $file, $originalTime) = @_;
+#          (increments CHANGED flag and sets corresponding WRITTEN tag)
+sub SetFileModifyDate($$;$$$)
+{
+    my ($self, $file, $originalTime, $tag, $isUnixTime) = @_;
     my $nvHash;
-    my $val = $self->GetNewValues('FileModifyDate', \$nvHash);
+    $tag = 'FileModifyDate' unless defined $tag;
+    my $val = $self->GetNewValue($tag, \$nvHash);
     return 0 unless defined $val;
-    my $isOverwriting = IsOverwriting($nvHash);
+    my $isOverwriting = $self->IsOverwriting($nvHash);
     return 0 unless $isOverwriting;
+    # can currently only set creation date on Windows systems
+    # (and Mac now too, but that is handled with the MacOS tags)
+    return 0 if $tag eq 'FileCreateDate' and $^O ne 'MSWin32';
     if ($isOverwriting < 0) {  # are we shifting time?
         # use original time of this file if not specified
-        $originalTime = -M $file unless defined $originalTime;
-        return 0 unless defined $originalTime;
-        return 0 unless IsOverwriting($nvHash, $^T - $originalTime*(24*3600));
-        $val = $nvHash->{Value}[0]; # get shifted value
-    }
-    unless (utime($val, $val, $file)) {
-        $self->Warn('Error setting FileModifyDate');
-        return -1;
-    }
-    ++$self->{CHANGED};
-    $self->VerboseValue('+ FileModifyDate', $val);
+        unless (defined $originalTime) {
+            my ($aTime, $mTime, $cTime) = $self->GetFileTime($file);
+            $originalTime = ($tag eq 'FileCreateDate') ? $cTime : $mTime;
+            return 0 unless defined $originalTime;
+            $isUnixTime = 1;
+        }
+        $originalTime = int($^T - $originalTime*(24*3600) + 0.5) unless $isUnixTime;
+        return 0 unless $self->IsOverwriting($nvHash, $originalTime);
+        $val = $$nvHash{Value}[0]; # get shifted value
+    }
+    my ($aTime, $mTime, $cTime);
+    if ($tag eq 'FileCreateDate') {
+        eval { require Win32::API } or $self->WarnOnce("Install Win32::API to set $tag"), return -1;
+        eval { require Win32API::File } or $self->WarnOnce("Install Win32API::File to set $tag"), return -1;
+        $cTime = $val;
+    } else {
+        $aTime = $mTime = $val;
+    }
+    $self->SetFileTime($file, $aTime, $mTime, $cTime, 1) or $self->Warn("Error setting $tag"), return -1;
+    ++$$self{CHANGED};
+    $$self{WRITTEN}{$tag} = $val;   # remember that we wrote this tag
+    $self->VerboseValue("+ $tag", $val);
     return 1;
 }
@@ -1437,51 +1856,142 @@
 # Change file name and/or directory from FileName and Directory tags
 # Inputs: 0) ExifTool object reference, 1) current file name (including path)
-#         2) New name (or undef to build from FileName and Directory tags)
+#         2) new name (or undef to build from FileName and Directory tags)
+#         3) option: 'HardLink'/'SymLink' to create hard/symbolic link instead of renaming
+#                    'Test' to only print new file name
+#         4) 0 to indicate that a file will no longer exist (used for 'Test' only)
 # Returns: 1=name changed OK, 0=nothing changed, -1=error changing name
 #          (and increments CHANGED flag if filename changed)
 # Notes: Will not overwrite existing file.  Creates directories as necessary.
-sub SetFileName($$;$)
-{
-    my ($self, $file, $newName) = @_;
+sub SetFileName($$;$$$)
+{
+    my ($self, $file, $newName, $opt, $usedFlag) = @_;
     my ($nvHash, $doName, $doDir);
+
+    $opt or $opt = '';
     # determine the new file name
     unless (defined $newName) {
-        my $filename = $self->GetNewValues('FileName', \$nvHash);
-        $doName = 1 if defined $filename and IsOverwriting($nvHash, $file);
-        my $dir = $self->GetNewValues('Directory', \$nvHash);
-        $doDir = 1 if defined $dir and IsOverwriting($nvHash, $file);
-        return 0 unless $doName or $doDir;  # nothing to do
-        if ($doName) {
-            $newName = GetNewFileName($file, $filename);
-            $newName = GetNewFileName($newName, $dir) if $doDir;
+        if ($opt) {
+            if ($opt eq 'HardLink' or $opt eq 'Link') {
+                $newName = $self->GetNewValue('HardLink');
+            } elsif ($opt eq 'SymLink') {
+                $newName = $self->GetNewValue('SymLink');
+            } elsif ($opt eq 'Test') {
+                $newName = $self->GetNewValue('TestName');
+            }
+            return 0 unless defined $newName;
         } else {
-            $newName = GetNewFileName($file, $dir);
-        }
-    }
-    if (-e $newName) {
-        # don't replace existing file
-        $self->Warn("File '$newName' already exists");
-        return -1;
+            my $filename = $self->GetNewValue('FileName', \$nvHash);
+            $doName = 1 if defined $filename and $self->IsOverwriting($nvHash, $file);
+            my $dir = $self->GetNewValue('Directory', \$nvHash);
+            $doDir = 1 if defined $dir and $self->IsOverwriting($nvHash, $file);
+            return 0 unless $doName or $doDir;  # nothing to do
+            if ($doName) {
+                $newName = GetNewFileName($file, $filename);
+                $newName = GetNewFileName($newName, $dir) if $doDir;
+            } else {
+                $newName = GetNewFileName($file, $dir);
+            }
+        }
+    }
+    # validate new file name in Windows
+    if ($^O eq 'MSWin32') {
+        if ($newName =~ /[\0-\x1f<>"|*]/) {
+            $self->Warn('New file name not allowed in Windows (contains reserved characters)');
+            return -1;
+        }
+        if ($newName =~ /:/ and $newName !~ /^[A-Z]:[^:]*$/i) {
+            $self->Warn("New file name not allowed in Windows (contains ':')");
+            return -1;
+        }
+        if ($newName =~ /\?/ and $newName !~ m{^[\\/]{2}\?[\\/][^?]*$}) {
+            $self->Warn("New file name not allowed in Windows (contains '?')");
+            return -1;
+        }
+        if ($newName =~ m{(^|[\\/])(CON|PRN|AUX|NUL|COM[1-9]|LPT[1-9])(\.[^.]*)?$}i) {
+            $self->Warn('New file name not allowed in Windows (reserved device name)');
+            return -1;
+        }
+        if ($newName =~ /([. ])$/) {
+            $self->Warn("New file name not recommended for Windows (ends with '${1}')", 2) and return -1;
+        }
+        if (length $newName > 259 and $newName !~ /\?/) {
+            $self->Warn('New file name not recommended for Windows (exceeds 260 chars)', 2) and return -1;
+        }
+    } else {
+        $newName =~ tr/\0//d;   # make sure name doesn't contain nulls
+    }
+    # protect against empty file name
+    length $newName or $self->Warn('New file name is empty'), return -1;
+    # don't replace existing file
+    if ($self->Exists($newName) and (not defined $usedFlag or $usedFlag)) {
+        if ($file ne $newName or $opt =~ /Link$/) {
+            # allow for case-insensitive filesystem
+            if ($opt =~ /Link$/ or not $self->IsSameFile($file, $newName)) {
+                $self->Warn("File '${newName}' already exists");
+                return -1;
+            }
+        } else {
+            $self->Warn('File name is unchanged');
+            return 0;
+        }
+    }
+    if ($opt eq 'Test') {
+        my $out = $$self{OPTIONS}{TextOut};
+        print $out "'${file}' --> '${newName}'\n";
+        return 1;
     }
     # create directory for new file if necessary
     my $result;
-    if (($result = CreateDirectory($newName)) != 0) {
+    if (($result = $self->CreateDirectory($newName)) != 0) {
         if ($result < 0) {
-            $self->Warn("Error creating directory for '$newName'");
+            $self->Warn("Error creating directory for '${newName}'");
             return -1;
         }
-        $self->VPrint(0, "Created directory for '$newName'");
+        $self->VPrint(0, "Created directory for '${newName}'\n");
+    }
+    if ($opt eq 'HardLink' or $opt eq 'Link') {
+        unless (link $file, $newName) {
+            $self->Warn("Error creating hard link '${newName}'");
+            return -1;
+        }
+        ++$$self{CHANGED};
+        $self->VerboseValue('+ HardLink', $newName);
+        return 1;
+    } elsif ($opt eq 'SymLink') {
+        $^O eq 'MSWin32' and $self->Warn('SymLink not supported in Windows'), return -1;
+        $newName =~ s(^\./)();  # remove leading "./" from link name if it exists
+        # path to linked file must be relative to the $newName directory, but $file
+        # is relative to the current directory, so convert it to an absolute path
+        # if using a relative directory and $newName isn't in the current directory
+        if ($file !~ m(^/) and $newName =~ m(/)) {
+            unless (eval { require Cwd }) {
+                $self->Warn('Install Cwd to make symlinks to other directories');
+                return -1;
+            }
+            $file = eval { Cwd::abs_path($file) };
+            unless (defined $file) {
+                $self->Warn('Error in Cwd::abs_path when creating symlink');
+                return -1;
+            }
+        }
+        unless (eval { symlink $file, $newName } ) {
+            $self->Warn("Error creating symbolic link '${newName}'");
+            return -1;
+        }
+        ++$$self{CHANGED};
+        $self->VerboseValue('+ SymLink', $newName);
+        return 1;
     }
     # attempt to rename the file
-    unless (rename $file, $newName) {
+    unless ($self->Rename($file, $newName)) {
         local (*EXIFTOOL_SFN_IN, *EXIFTOOL_SFN_OUT);
         # renaming didn't work, so copy the file instead
-        unless (open EXIFTOOL_SFN_IN, $file) {
-            $self->Warn("Error opening '$file'");
+        unless ($self->Open(\*EXIFTOOL_SFN_IN, $file)) {
+            $self->Error("Error opening '${file}'");
             return -1;
         }
-        unless (open EXIFTOOL_SFN_OUT, ">$newName") {
+        unless ($self->Open(\*EXIFTOOL_SFN_OUT, $newName, '>')) {
             close EXIFTOOL_SFN_IN;
-            $self->Warn("Error creating '$newName'");
+            $self->Error("Error creating '${newName}'");
             return -1;
         }
@@ -1495,16 +2005,16 @@
         close EXIFTOOL_SFN_IN;
         if ($err) {
-            unlink $newName;    # erase bad output file
-            $self->Warn("Error writing '$newName'");
+            $self->Unlink($newName);    # erase bad output file
+            $self->Error("Error writing '${newName}'");
             return -1;
         }
         # preserve modification time
-        my $modTime = $^T - (-M $file) * (24 * 3600);
-        my $accTime = $^T - (-A $file) * (24 * 3600);
-        utime($accTime, $modTime, $newName);
+        my ($aTime, $mTime, $cTime) = $self->GetFileTime($file);
+        $self->SetFileTime($newName, $aTime, $mTime, $cTime);
         # remove the original file
-        unlink $file or $self->Warn('Error removing old file');
-    }
-    ++$self->{CHANGED};
+        $self->Unlink($file) or $self->Warn('Error removing old file');
+    }
+    $$self{NewName} = $newName; # remember new file name
+    ++$$self{CHANGED};
     $self->VerboseValue('+ FileName', $newName);
     return 1;
@@ -1512,7 +2022,60 @@
 
 #------------------------------------------------------------------------------
+# Set file permissions, group/user id and various MDItem tags from new tag values
+# Inputs: 0) ExifTool ref, 1) file name or glob (must be a name for MDItem tags)
+# Returns: 1=something was set OK, 0=didn't try, -1=error (and warning set)
+# Notes: There may be errors even if 1 is returned
+sub SetSystemTags($$)
+{
+    my ($self, $file) = @_;
+    my $result = 0;
+
+    my $perm = $self->GetNewValue('FilePermissions');
+    if (defined $perm) {
+        if (eval { chmod($perm & 07777, $file) }) {
+            $self->VerboseValue('+ FilePermissions', $perm);
+            $result = 1;
+        } else {
+            $self->WarnOnce('Error setting FilePermissions');
+            $result = -1;
+        }
+    }
+    my $uid = $self->GetNewValue('FileUserID');
+    my $gid = $self->GetNewValue('FileGroupID');
+    if (defined $uid or defined $gid) {
+        defined $uid or $uid = -1;
+        defined $gid or $gid = -1;
+        if (eval { chown($uid, $gid, $file) }) {
+            $self->VerboseValue('+ FileUserID', $uid) if $uid >= 0;
+            $self->VerboseValue('+ FileGroupID', $gid) if $gid >= 0;
+            $result = 1;
+        } else {
+            $self->WarnOnce('Error setting FileGroup/UserID');
+            $result = -1 unless $result;
+        }
+    }
+    my $tag;
+    foreach $tag (@writableMacOSTags) {
+        my $nvHash;
+        my $val = $self->GetNewValue($tag, \$nvHash);
+        next unless $nvHash;
+        if ($^O eq 'darwin') {
+            ref $file and $self->Warn('Setting MDItem tags requires a file name'), last;
+            require Image::ExifTool::MacOS;
+            my $res = Image::ExifTool::MacOS::SetMacOSTags($self, $file, \@writableMacOSTags);
+            $result = $res if $res == 1 or not $result;
+            last;
+        } elsif ($tag ne 'FileCreateDate') {
+            $self->WarnOnce('Can only set MDItem tags on OS X');
+            last;
+        }
+    }
+    return $result;
+}
+
+#------------------------------------------------------------------------------
 # Write information back to file
 # Inputs: 0) ExifTool object reference,
-#         1) input filename, file ref, or scalar ref (or '' or undef to create from scratch)
+#         1) input filename, file ref, RAF ref, or scalar ref (or '' or undef to create from scratch)
 #         2) output filename, file ref, or scalar ref (or undef to overwrite)
 #         3) optional output file type (required only if input file is not specified
@@ -1524,19 +2087,30 @@
     my ($self, $infile, $outfile, $outType) = @_;
     my (@fileTypeList, $fileType, $tiffType, $hdr, $seekErr, $type, $tmpfile);
-    my ($inRef, $outRef, $closeIn, $closeOut, $outPos, $outBuff, $eraseIn);
-    my $oldRaf = $self->{RAF};
+    my ($inRef, $outRef, $closeIn, $closeOut, $outPos, $outBuff, $eraseIn, $raf, $fileExt);
+    my ($hardLink, $symLink, $testName);
+    my $oldRaf = $$self{RAF};
     my $rtnVal = 0;
 
     # initialize member variables
     $self->Init();
+    $$self{IsWriting} = 1;
 
     # first, save original file modify date if necessary
     # (do this now in case we are modifying file in place and shifting date)
-    my ($nvHash, $originalTime);
-    my $fileModifyDate =  $self->GetNewValues('FileModifyDate', \$nvHash);
-    if (defined $fileModifyDate and IsOverwriting($nvHash) < 0 and
+    my ($nvHash, $nvHash2, $originalTime, $createTime);
+    my $setModDate = defined $self->GetNewValue('FileModifyDate', \$nvHash);
+    my $setCreateDate = defined $self->GetNewValue('FileCreateDate', \$nvHash2);
+    my ($aTime, $mTime, $cTime);
+    if ($setModDate and $self->IsOverwriting($nvHash) < 0 and
         defined $infile and ref $infile ne 'SCALAR')
     {
-        $originalTime = -M $infile;
+        ($aTime, $mTime, $cTime) = $self->GetFileTime($infile);
+        $originalTime = $mTime;
+    }
+    if ($setCreateDate and $self->IsOverwriting($nvHash2) < 0 and
+        defined $infile and ref $infile ne 'SCALAR')
+    {
+        ($aTime, $mTime, $cTime) = $self->GetFileTime($infile) unless defined $cTime;
+        $createTime = $cTime;
     }
 #
